# Native SSL

Let us assume you want to send a very important transaction you want to keep secret. You would open your wallet, which is connected to a local or remote daemon, create your transaction and everything is private. The truth is it is not and here is why. For the setup of vital security mechanisms of a transaction, your wallet will ask the daemon to provide data for doing so. Everyone with access to this data is able to link the transaction to your wallet making the built-in anonymous feature almost worthless. For other services, this is even worse as they share more data. For example remote wallets, like the payment gate service, which also transfers data in such a way that anyone viewing said data will have access to your wallet. Therefore it is crucial to guarantee your data stays private and secure and only readable by you and the service you are connected to. In the following, we will shortly introduce two different ways an attacker may read your data and how the native SSL implementation in Galaxia mitigates these issues.

## None Encrypted Data

Once data is sent from one application to another they use a network protocol to communicate with each other. These protocols tend to be readable by every application on your computer and the computer running the service. Thus, in order to keep your data private and secure, you must translate your message to guarantee that only the designated receiver can read it and others only see something they can not understand. This is a common problem in computer science and is solved by using encryption. In short, this works with a so-called public key each participant offers to the network. Every application can use this public key to encrypt their message in such a way that only the publisher can read it after. Even you would not be able to read that message once encrypted.

With encryption you can now publish two public keys, one for the client you are using and one for the service they are connected to and as long as you keep the data encrypted with the key of the participant you want to read the data no one else is able to intercept and read it.

Many users are not aware of this or are simply not able to pull out the technological effort to set encryption up. Even users who know how to mostly use a third party application to secure traffic leaving your local computer. However, this is not as secure as it should be because it does not prevent you from malicious software running on the computer used.

Galaxia has pulled native encryption support into every application. As a result, you will not need to configure any complex third party application to secure your data and you are also able to be more secure even against malicious software running on your local instance.

## Peer Verification

The previous scenario still has an attacking vector. As described earlier to encrypt data correctly you need to have the peers public key. But what if an attacker intercepts your connection and gives you their public key instead of the desired one. The attacker then acts as a proxy forwarding every request/response back from you and the peer you wanted to connect to and can read every message sent as it was encrypted with his public key. This is commonly known as a Man-in-the-middle attack. In this case, things get even worse as the attacker would also be able to alter the messages and replace them partially with his own data, for example redirecting transactions or show incoming transactions to the user that does not exist.

To help mitigate this Galaxia has built-in peer verification. The approach is simple, you first get the public key of the receiver from a trusted source, like asking the provider or generating the public key yourself. The trusted peers' public keys will then be located to next to the Galaxia applications and they will accept connections only if they use one of the public keys you marked as trusted.

## Conclusion

All this technological stuff may sound confusing and one may not be able to understand the impact of not using a native SSL implementation. Additionally, this feature is hard to pull off for a non-technical person. In short, if you do not secure your connection once you get attacked the attacker is most likely able to show you any information they choose, view everything you want to keep private and finally harm the network by having insides of partial data that was assumed to be anonymous in the network. Therefore we at Galaxia put a lot of effort into integrating SSL natively doing the hard part for you to secure the community and provided a much easier way for users to use SSL. You can find a tutorial on setting up SSL for your local instance [here](../../ssl). If you have any trouble setting it up or partially do not understand something please let us know as we are continuously trying to improve on a secure network.
